pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT > Class Template Reference
Module keypoints

HarrisKeypoint2D detects Harris corners family points. More...

`#include <pcl/keypoints/harris_2d.h>`

Inheritance diagram for pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >:

## Public Types

enum | ResponseMethod { HARRIS = 1, NOBLE, LOWE, TOMASI }
typedef boost::shared_ptr< HarrisKeypoint2D< PointInT, PointOutT, IntensityT > > | Ptr
typedef boost::shared_ptr< const HarrisKeypoint2D< PointInT, PointOutT, IntensityT > > | ConstPtr
typedef Keypoint< PointInT, PointOutT >::PointCloudIn | PointCloudIn
typedef Keypoint< PointInT, PointOutT >::PointCloudOut | PointCloudOut
typedef Keypoint< PointInT, PointOutT >::KdTree | KdTree
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
Public Types inherited from pcl::Keypoint< PointInT, PointOutT >
typedef boost::shared_ptr< Keypoint< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Keypoint< PointInT, PointOutT > > | ConstPtr
typedef PCLBase< PointInT > | BaseClass
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(int, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, int index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| HarrisKeypoint2D (ResponseMethod method=HARRIS, int window_width=3, int window_height=3, int min_distance=5, float threshold=0.0)
| Constructor. More...
void | setMethod (ResponseMethod type)
| set the method of the response to be calculated. More...
void | setWindowWidth (int window_width)
| Set window width. More...
void | setWindowHeight (int window_height)
| Set window height. More...
void | setSkippedPixels (int skipped_pixels)
| Set number of pixels to skip. More...
void | setMinimalDistance (int min_distance)
| Set minimal distance between candidate keypoints. More...
void | setThreshold (float threshold)
| set the threshold value for detecting corners. More...
void | setNonMaxSupression (bool=false)
| whether non maxima suppression should be applied or the response for each point should be returned More...
void | setRefine (bool do_refine)
| whether the detected key points should be refined or not. More...
void | setNumberOfThreads (unsigned int nr_threads=0)
| Initialize the scheduler and set the number of threads to use. More...
Public Member Functions inherited from pcl::Keypoint< PointInT, PointOutT >
| Keypoint ()
| Empty constructor. More...
virtual | ~Keypoint ()
| Empty destructor. More...
virtual void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to the input dataset that we need to estimate features at every point for. More...
PointCloudInConstPtr | getSearchSurface ()
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used. More...
double | getSearchParameter ()
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch ()
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the key point detection. More...
double | getRadiusSearch ()
| Get the sphere radius used for determining the neighbors. More...
pcl::PointIndicesConstPtr | getKeypointsIndices ()
void | compute (PointCloudOut &output)
| Base method for key point detection for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
int | searchForNeighbors (int index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

bool | initCompute ()
void | detectKeypoints (PointCloudOut &output)
| Abstract key point detection method. More...
void | responseHarris (PointCloudOut &output) const
| gets the corner response for valid input points More...
void | responseNoble (PointCloudOut &output) const
void | responseLowe (PointCloudOut &output) const
void | responseTomasi (PointCloudOut &output) const
void | computeSecondMomentMatrix (std::size_t pos, float *coefficients) const
| calculates the upper triangular part of unnormalized covariance matrix over intensities given by the 2D coordinates and window_width_ and window_height_ More...
Protected Member Functions inherited from pcl::Keypoint< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

float | threshold_
| threshold for non maxima suppression More...
bool | refine_
| corner refinement More...
bool | nonmax_
| non maximas suppression More...
ResponseMethod | method_
| cornerness computation methode More...
unsigned int | threads_
| number of threads to be used More...
Protected Attributes inherited from pcl::Keypoint< PointInT, PointOutT >
std::string | name_
| The key point detection method's name. More...
SearchMethod | search_method_
| The search method template for indices. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (casted from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
pcl::PointIndicesPtr | keypoints_indices_
| Indices of the keypoints in the input cloud. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointOutT, typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>
class pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >

HarrisKeypoint2D detects Harris corners family points.

Author
  Nizar Sallem

Definition at line 54 of file harris_2d.h.

## Member Typedef Documentation

template<typename PointInT , typename PointOutT , typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef boost::shared_ptr<const HarrisKeypoint2D<PointInT, PointOutT, IntensityT> > pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::ConstPtr

Definition at line 58 of file harris_2d.h.

template<typename PointInT , typename PointOutT , typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef Keypoint<PointInT, PointOutT>::KdTree pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::KdTree

Definition at line 62 of file harris_2d.h.

template<typename PointInT , typename PointOutT , typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef Keypoint<PointInT, PointOutT>::PointCloudIn pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::PointCloudIn

Definition at line 60 of file harris_2d.h.

template<typename PointInT , typename PointOutT , typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef PointCloudIn::ConstPtr pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::PointCloudInConstPtr

Definition at line 63 of file harris_2d.h.

template<typename PointInT , typename PointOutT , typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef Keypoint<PointInT, PointOutT>::PointCloudOut pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::PointCloudOut

Definition at line 61 of file harris_2d.h.

template<typename PointInT , typename PointOutT , typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

typedef boost::shared_ptr<HarrisKeypoint2D<PointInT, PointOutT, IntensityT> > pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::Ptr

Definition at line 57 of file harris_2d.h.

## Member Enumeration Documentation

template<typename PointInT , typename PointOutT , typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

enum pcl::HarrisKeypoint2D::ResponseMethod

Enumerator
HARRIS |
NOBLE |
LOWE |
TOMASI |

Definition at line 70 of file harris_2d.h.

## Constructor & Destructor Documentation

template<typename PointInT , typename PointOutT , typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::HarrisKeypoint2D | ( | ResponseMethod | method = `HARRIS`,
|  | int | window_width = `3`,
|  | int | window_height = `3`,
|  | int | min_distance = `5`,
|  | float | threshold = `0.0`
| ) |  |

inline

Constructor.

Parameters

  [in] | method | the method to be used to determine the corner responses
  | window_width |
  | window_height |
  | min_distance |
  [in] | threshold | the threshold to filter out weak corners

Definition at line 79 of file harris_2d.h.

References pcl::Keypoint< PointInT, PointOutT >::name_, pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setMethod(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setMinimalDistance(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setNonMaxSupression(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setRefine(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setSkippedPixels(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setThreshold(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setWindowHeight(), and pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setWindowWidth().

## Member Function Documentation

template<typename PointInT , typename PointOutT , typename IntensityT >

void pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::computeSecondMomentMatrix | ( | std::size_t | pos,
|  | float * | coefficients
| ) |  | const

protected

calculates the upper triangular part of unnormalized covariance matrix over intensities given by the 2D coordinates and window_width_ and window_height_

Definition at line 101 of file harris_2d.hpp.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setNumberOfThreads().

template<typename PointInT , typename PointOutT , typename IntensityT >

void pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints | ( | PointCloudOut & | output | ) |

protected virtual

Abstract key point detection method.

!! nsallem 20120220 : we don't test here for density so if one term in nan the result is nan

Implements pcl::Keypoint< PointInT, PointOutT >.

Definition at line 173 of file harris_2d.hpp.

References pcl::PointCloud< PointT >::clear(), pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::is_dense, pcl::isFinite(), pcl::PointCloud< PointT >::push_back(), pcl::PointCloud< PointT >::reserve(), pcl::PointCloud< PointT >::size(), and pcl::PointCloud< PointT >::width.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setNumberOfThreads().

template<typename PointInT , typename PointOutT , typename IntensityT >

bool pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::initCompute | ( |  | ) |

protected virtual

Reimplemented from pcl::Keypoint< PointInT, PointOutT >.

Definition at line 127 of file harris_2d.hpp.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setNumberOfThreads().

template<typename PointInT , typename PointOutT , typename IntensityT >

void pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseHarris | ( | PointCloudOut & | output | ) | const

protected

gets the corner response for valid input points

Definition at line 293 of file harris_2d.hpp.

References pcl::PointCloud< PointT >::clear(), pcl::PointCloud< PointT >::height, pcl::isFinite(), pcl::PointCloud< PointT >::points, pcl::PointCloud< PointT >::resize(), pcl::PointCloud< PointT >::size(), and pcl::PointCloud< PointT >::width.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setNumberOfThreads().

template<typename PointInT , typename PointOutT , typename IntensityT >

void pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseLowe | ( | PointCloudOut & | output | ) | const

protected

Definition at line 365 of file harris_2d.hpp.

References pcl::PointCloud< PointT >::clear(), pcl::PointCloud< PointT >::height, pcl::isFinite(), pcl::PointCloud< PointT >::points, pcl::PointCloud< PointT >::resize(), pcl::PointCloud< PointT >::size(), and pcl::PointCloud< PointT >::width.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setNumberOfThreads().

template<typename PointInT , typename PointOutT , typename IntensityT >

void pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseNoble | ( | PointCloudOut & | output | ) | const

protected

Definition at line 329 of file harris_2d.hpp.

References pcl::PointCloud< PointT >::clear(), pcl::PointCloud< PointT >::height, pcl::isFinite(), pcl::PointCloud< PointT >::points, pcl::PointCloud< PointT >::resize(), pcl::PointCloud< PointT >::size(), and pcl::PointCloud< PointT >::width.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setNumberOfThreads().

template<typename PointInT , typename PointOutT , typename IntensityT >

void pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseTomasi | ( | PointCloudOut & | output | ) | const

protected

Definition at line 401 of file harris_2d.hpp.

References pcl::PointCloud< PointT >::clear(), pcl::PointCloud< PointT >::height, pcl::isFinite(), pcl::PointCloud< PointT >::points, pcl::PointCloud< PointT >::resize(), pcl::PointCloud< PointT >::size(), and pcl::PointCloud< PointT >::width.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setNumberOfThreads().

template<typename PointInT , typename PointOutT , typename IntensityT >

void pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setMethod | ( | ResponseMethod | type | ) |

set the method of the response to be calculated.

Parameters

  [in] | type |

Definition at line 45 of file harris_2d.hpp.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::HarrisKeypoint2D().

template<typename PointInT , typename PointOutT , typename IntensityT >

void pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setMinimalDistance | ( | int | min_distance | ) |

Set minimal distance between candidate keypoints.

Definition at line 94 of file harris_2d.hpp.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::HarrisKeypoint2D().

template<typename PointInT , typename PointOutT , typename IntensityT >

void pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setNonMaxSupression | ( | bool | nonmax = `false` | ) |

whether non maxima suppression should be applied or the response for each point should be returned

Note
  this value needs to be turned on in order to apply thresholding and refinement

Parameters

  [in] | nonmax | default is false

Definition at line 66 of file harris_2d.hpp.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::HarrisKeypoint2D().

template<typename PointInT , typename PointOutT , typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

void pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setNumberOfThreads | ( | unsigned int | nr_threads = `0` | ) |

inline

Initialize the scheduler and set the number of threads to use.

Parameters

  nr_threads | the number of hardware threads to use (0 sets the value back to automatic)

Definition at line 134 of file harris_2d.h.

References pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::computeSecondMomentMatrix(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::initCompute(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseHarris(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseLowe(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseNoble(), pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::responseTomasi(), and pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::threads_.

template<typename PointInT , typename PointOutT , typename IntensityT >

void pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setRefine | ( | bool | do_refine | ) |

whether the detected key points should be refined or not.

If turned of, the key points are a subset of the original point cloud. Otherwise the key points may be arbitrary. note non maxima supression needs to be on in order to use this feature.

Parameters

  [in] | do_refine |

Definition at line 59 of file harris_2d.hpp.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::HarrisKeypoint2D().

template<typename PointInT , typename PointOutT , typename IntensityT >

void pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setSkippedPixels | ( | int | skipped_pixels | ) |

Set number of pixels to skip.

Definition at line 87 of file harris_2d.hpp.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::HarrisKeypoint2D().

template<typename PointInT , typename PointOutT , typename IntensityT >

void pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setThreshold | ( | float | threshold | ) |

set the threshold value for detecting corners.

This is only evaluated if non maxima suppression is turned on. note non maxima suppression needs to be activated in order to use this feature.

Parameters

  [in] | threshold |

Definition at line 52 of file harris_2d.hpp.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::HarrisKeypoint2D().

template<typename PointInT , typename PointOutT , typename IntensityT >

void pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setWindowHeight | ( | int | window_height | ) |

Set window height.

Definition at line 80 of file harris_2d.hpp.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::HarrisKeypoint2D().

template<typename PointInT , typename PointOutT , typename IntensityT >

void pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setWindowWidth | ( | int | window_width | ) |

Set window width.

Definition at line 73 of file harris_2d.hpp.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::HarrisKeypoint2D().

## Member Data Documentation

template<typename PointInT , typename PointOutT , typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

ResponseMethod pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::method_

protected

cornerness computation methode

Definition at line 164 of file harris_2d.h.

template<typename PointInT , typename PointOutT , typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

bool pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::nonmax_

protected

non maximas suppression

Definition at line 162 of file harris_2d.h.

template<typename PointInT , typename PointOutT , typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

bool pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::refine_

protected

corner refinement

Definition at line 160 of file harris_2d.h.

template<typename PointInT , typename PointOutT , typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

unsigned int pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::threads_

protected

number of threads to be used

Definition at line 166 of file harris_2d.h.

Referenced by pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::setNumberOfThreads().

template<typename PointInT , typename PointOutT , typename IntensityT = pcl::common::IntensityFieldAccessor<PointInT>>

float pcl::HarrisKeypoint2D< PointInT, PointOutT, IntensityT >::threshold_

protected

threshold for non maxima suppression

Definition at line 158 of file harris_2d.h.

The documentation for this class was generated from the following files:

- /build/pcl-6_P28C/pcl-1.7.2/keypoints/include/pcl/keypoints/harris_2d.h
- /build/pcl-6_P28C/pcl-1.7.2/keypoints/include/pcl/keypoints/impl/harris_2d.hpp